Summary:        A Mixed Integer Linear Programming (MILP) solver
Name:           lpsolve
Version:        5.5.2.11
Release:        1%{?dist}
License:        LGPL-2.1-or-later AND GPL-2.0-or-later WITH Bison-exception-2.2 AND BSD-3-clause
URL:            https://sourceforge.net/projects/lpsolve
Source:         http://downloads.sourceforge.net/lpsolve/lp_solve_%{version}_source.tar.gz

Patch3000:      lp_solve-5.5.2.11-Respect-CC-CFLAGS-and-LDFLAGS.patch
Patch3001:      lp_solve-5.5.2.11-Port-to-C99.patch
Patch3002:      lp_solve-5.5.2.11-Link-a-tool-to-a-shared-library.patch
# https://gitlab.com/fedora/legal/fedora-license-data/-/issues/230
# Update colamd.{c,h} to fix license issues
Patch3003:      lp_solve-5.5.2.11-Rebase-COLAMD-to-3.0.4.patch
Patch3004:      lp_solve-5.5.2.11-Port-lp_MDO-to-colamd-3.0.4.patch

BuildRequires:  gcc-c++
BuildRequires:  bash binutils coreutils grep
Provides:       bundled(colamd) = 3.0.4

%description
This package provides Mixed Integer Linear Programming (MILP) solver lpsolve, which can be 
used to solve pure linear, (mixed) integer/binary, semi-continuous and special ordered sets 
(SOS) models.

%package devel
Summary:  Files for developing with lpsolve
License:  LGPL-2.1-or-later
Requires: %{name} = %{version}-%{release}

%description devel
This package includes and definitions for developing with lpsolve.

%prep
%setup -n lp_solve_5.5
rm colamd/colamd.{c,h}
%autopatch -p1
mv colamd/License.txt colamd/colamd_license
chmod -x lp_lib.h

%build
%set_build_flags
pushd lpsolve55
sh -x ccc
rm bin/ux*/liblpsolve55.a
popd
pushd lp_solve
sh -x ccc
popd

%install
rm -rf %{buildroot}
install -d %{buildroot}%{_bindir} %{buildroot}%{_libdir} %{buildroot}%{_includedir}/lpsolve
install -p -m 755 lp_solve/bin/ux*/lp_solve %{buildroot}%{_bindir}
install -p -m 755 lpsolve55/bin/ux*/liblpsolve55.so %{buildroot}%{_libdir}
install -p -m 644 lp*.h %{buildroot}%{_includedir}/lpsolve

%check
LP_PATH="$(echo lpsolve55/bin/ux*)"
echo 'max: x; x < 42;' | \
    LD_LIBRARY_PATH="$LP_PATH" ./lp_solve/bin/ux*/lp_solve -S1 | \
    grep -e ': 42\.0*$'
%set_build_flags
${CC} ${CFLAGS} -I. demo/demo.c ${LDFLAGS} -L"$LP_PATH" -llpsolve55
LD_LIBRARY_PATH="$LP_PATH" ./a.out </dev/null

%files
%license colamd/colamd_license
%doc README.txt
%{_bindir}/lp_solve
%{_libdir}/*.so

%files devel
%doc demo/demo.c
%{_includedir}/lpsolve

%changelog
* Mon Dec 11 2023 Upgrade Robot <upbot@opencloudos.org> - 5.5.2.11-1
- Upgrade to version 5.5.2.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.5.2.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.5.2.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.5.2.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Dec 26 2022 Wang Guodong <gordonwwang@tencent.com> - 5.5.2.0-1
- package init.
